<?php
/**
 *   Medals System Plugin for MyBB (admin)
 *   Website: http://www.ncaabbs.com
 *   Version: 1.1
 *   Copyright  2007
 *   King Butter - NCAAbbs SkunkWorks Team
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License along
 *   with this program; if not, write to the Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *   Tr eviri: www.MyBBoard.Gen.TR adna dared
 */

define('IN_MYBB', 1);

require_once './global.php';
$lang->load("medals");
addacpnav($lang->nav_medals, "medals.php?".SID);
checkadminpermissions('canadminmedals');
logadmin();

// Set the upload path for medals
	
$dirpath = MYBB_ROOT.$mybb->settings['uploadspath'].'/medals';


// Check if the upload path exists
if (!$dir = opendir($dirpath))
die($lang->medal_dir_missing.' - mkdir '.$dirpath);

// Check if the upload path is writable
else if (!is_writable($dirpath."/"))
die($lang->medals_dir.$dirpath.$lang->not_writable);


// Check for action
switch(trim($mybb->input['action']))
{

	case $lang->upload_medal:
	addacpnav($lang->upload_medal);
	cpheader();
	check_upload_form();
	submit_upload();
	break;

	case $lang->edit_managers:
	addacpnav($lang->edit_managers);
        cpheader();
	edit_managers_form($mybb->input['mid']);
	add_managers_form($mybb->input['mid']);
	break;

	case $lang->add_manager:
	 addacpnav($lang->add_manager);
        cpheader();
	add_manager_submit($mybb->input['mid'],$mybb->input['username']);
	break;

	case $lang->del_manager:
	 addacpnav($lang->del_manager);
        cpheader();
	delete_manager($mybb->input['mid'],$mybb->input['uid']);		
	break;
	
	case $lang->del_medal:
	addacpnav($lang->del_medal);
        cpheader();
	confirm_delete_form($mybb->input['mid']);
	break;

	case $lang->edit_medal:
	addacpnav($lang->edit_medal);
        cpheader();
	edit_medal_form($mybb->input['mid']);
	break;

	case $lang->kill_it:
        addacpnav($lang->kill_it);
        cpheader();
    	perform_delete($mybb->input['mid']);
	break;

	case $lang->confirm_medal_edit:
        addacpnav($lang->confirm_medal_edit);
        cpheader();
    	confirm_medal_edit($mybb->input['mid']);
	break;

	default:
	addacpnav($lang->nav_medals);
	cpheader();
	show_medals_list();
	show_medal_upload_form();
	break;


}
	cpfooter();


function show_medal_upload_form()
{
global $mybb,$menu,$lang;
startform($_SERVER['PHP_SELF'],"POST");
starttable();
tableheader("<span style=\"float: center;\">{$lang->upload_new_medal}</span>");
$bgcolor = getaltbg();
echo makeinputcode($lang->description,"description");
makeuploadcode($lang->upload_medal_file,"medalfile");
$bgcolor = getaltbg();
echo "<tr><td class=\"{$bgcolor}\">&nbsp;</td><td class=\"{$bgcolor}\">";
echo makebuttoncode("action",$lang->upload_medal);
echo "</td></tr>";
endtable();
endform();
}

function edit_medal_form($mid)
{


global $mybb,$db,$lang;
$medals_query = $db->query("select * from `".TABLE_PREFIX."medals_list` where mid=".$mid);
$medal_list = $db->fetch_array($medals_query);
$imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath']."/medals/".$mid.".jpg";

startform($_SERVER['PHP_SELF'],"POST");
starttable();
tableheader("{$lang->edit_medal}: ".$medal_list['description']."<img src=\"".$imgsrc."\" width=\"20\" height=\"40\">");
$bgcolor = getaltbg();
echo makeinputcode($lang->description,"description",$medal_list['description']);
makeuploadcode($lang->medal_img_file,"medalfile");
$bgcolor = getaltbg();
echo "<tr><td class=\"{$bgcolor}\">&nbsp;</td><td class=\"{$bgcolor}\">";
echo makebuttoncode("action",$lang->confirm_medal_edit);
echo "</td></tr>";
endtable();
echo makehiddencode("mid",$mid);
endform();
}


// Function for checking the upload form
function check_upload_form()
{
global $lang;
	$formerror = 0;
	if ($_POST['description'] == '')
	{
	$formerror = 1;
	starttable();
	tableheader("<span style=\"float: center;\">{$lang->upload_medal_error}</span>");
	echo "<tr><td>{$lang->pls_enter_desc}</td></tr>";
	}
	if (!$_FILES['medalfile']['name'])
	{
		if ($formerror == '0')
		{
		$formerror = 1;
		starttable();
		tableheader("<span style=\"float: center;\">{$lang->upload_medal_error}</span>");
		}
	echo "<tr><td>{$lang->pls_select_upload}</td></tr>";
	}
	
	if ($formerror == '1')
        {
	endtable();
	exit();
	}

}

// Fuction for processing the medal upload
function submit_upload()
{
	global $db,$mybb,$lang;
	// Set the upload path for medals
	
	$dirpath = MYBB_ROOT.$mybb->settings['uploadspath'].'/medals';
	starttable();
        $description = $db->escape_string($mybb->input['description']);
        $query = $db->query("INSERT INTO `".TABLE_PREFIX."medals_list` (`description`) VALUES (\"".$description."\")");
	$mid = $db->insert_id($query);
        if ($_FILES['medalfile']['error'] == '0')
        {
                $imgfile = $_FILES['medalfile']['tmp_name'];
                $newfile = $dirpath . "/" . $mid . ".jpg";
                if (!copy($imgfile, $newfile))
                {
                        // if an error occurs the file could not
                        // be written, read or possibly does not exist
        		$db->query("DELETE From `".TABLE_PREFIX."medals_list` where `mid` \"".$mid."\""); 
			tableheader("<span style=\"float: center;\">{$lang->current_medals}</span>","",3);
	                echo "<tr><td>{$lang->err_upload}".$newfile."</td></tr>";
			endtable();
			exit();
                }
	tableheader("<span style=\"float: center;\">{$lang->medal_added}</span>");
	echo "<tr><td>{$lang->medal} ".$mybb->input['description']." ".$lang->added_w_id." ".$mid."</td></tr>";
        }
        else
	{
	tableheader("<span style=\"float: center;\">{$lang->medal_add_error}</span>");
        echo "<tr><td>{$lang->error} ";
	$errornum = $_FILES['medalfile']['error'];
	echo $lang->file_error[$errornum];
	echo "</td></tr>";
	}
	endtable();
	show_medals_list();
        show_medal_upload_form();


}


// Function for displaying all medals in the system

function show_medals_list()
{
global $db , $mybb, $lang;

$medals_query = $db->query("select * from `".TABLE_PREFIX."medals_list`");
starttable();
tableheader("<span style=\"float: center;\">{$lang->current_medals}</span>","",3);

	echo "<tr><td class=\"subheader\"><strong>{$lang->medal_name}</strong></td>";
	echo "<td class=\"subheader\"><strong>{$lang->image}</strong></td>";
	echo "<td class=\"subheader\"><strong>{$lang->actions}</strong></tr>";

	// Set up the query and loop through the results
	if ($db->num_rows($medals_query) == '0')
	echo "<tr><td colspan=3 class=\"{$bgcolor}\">{$lang->no_medals_found}</td></tr>"; 
	else
	{
		
		while($medal_list = $db->fetch_array($medals_query))
		{
		$bgcolor = getaltbg();
		$imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath']."/medals/".$medal_list['mid'].".jpg";
		echo "<tr><td class=\"{$bgcolor}\">".$medal_list['description']."</td>";
		echo "<td class=\"{$bgcolor}\"><img src=\"".$imgsrc."\" width=\"20\" height=\"40\"></td>";
		echo "<td class=\"{$bgcolor}\">";
		startform($_SERVER['PHP_SELF'],"POST");
		echo makehiddencode("mid",$medal_list['mid']);
		echo makebuttoncode("action",$lang->edit_managers);
		echo makebuttoncode("action",$lang->del_medal);
		echo makebuttoncode("action",$lang->edit_medal);
		endform();
		echo "</td>";
		echo "</tr>";
		}
	}
endtable();
}

function edit_managers_form($mid)
{

global $mybb,$db,$lang;
$medals_query = $db->query("select * from `".TABLE_PREFIX."medals_list` where mid=".$mid);
$medal_list = $db->fetch_array($medals_query);
starttable();
$imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath']."/medals/".$mid.".jpg";
tableheader("<span style=\"float: center;\">{$lang->editing_managers} ".$medal_list['description']." <img src=\"".$imgsrc."\" width=\"20\" height=\"40\"></h2></span>");
$managers_query = $db->query("select * from `".TABLE_PREFIX."medals_managers` where mid=".$mid);

	if ($db->num_rows($managers_query) == '0')
	echo "<tr><td colspan=\"2\">{$lang->no_mgrs_found}</td></tr>"; 
	else
	{
	echo "<tr><td class=\"subheader\"><strong>{$lang->uname}</strong></td><td class=\"subheader\"><strong>{$lang->actions}</strong></td></tr>";
		while($manager_list = $db->fetch_array($managers_query))
                {
		echo "<tr><td>".uid_to_username($manager_list['uid'])."</td>";
        	echo "<td>";
		startform($_SERVER['PHP_SELF'],"POST");
		echo makehiddencode("mid",$mid);     
		echo makehiddencode("uid",$manager_list['uid']);     
		echo makebuttoncode("action",$lang->del_manager);
		endform();
		}

	}
endtable();

}

function delete_manager($mid,$uid)
{
global $db,$lang;
		starttable();
 		if ($db->query("delete from `".TABLE_PREFIX."medals_managers` where `mid` =".$mid." and `uid` =".$uid))
        	{
		tableheader("<span style=\"float: center;\">{$lang->man_del_pass}</span>");
	        echo "<tr><td>{$lang->del_from_mgr}</td></tr>";
                
		}
		else
                {
                tableheader("<span style=\"float: center;\">{$lang->mgr_del_fail}</span>");
		echo "<tr><td>{$lang->bad_query}</td></tr>";       
		} 
		endtable();
	 edit_managers_form($mid);
        add_managers_form($mid);


}

function add_managers_form($mid)
{
	global $mybb,$lang;
	startform($_SERVER['PHP_SELF'],"POST");
     
 	echo makehiddencode("mid",$mid);
	starttable();
	tableheader("<span style=\"float: center;\">{$lang->add_manager}</span>");
	echo makeinputcode($lang->mgr_uname,"username");
	echo "<tr><td>&nbsp;</td><td>";
	echo makebuttoncode("action",$lang->add_manager);
	echo "</td></tr>";
	endtable();
	endform();
}

function confirm_delete_form($mid)
{
global $mybb,$db,$lang;
$medals_query = $db->query("select * from `".TABLE_PREFIX."medals_list` where mid=".$mid);
$medal_list = $db->fetch_array($medals_query);

$imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath']."/medals/".$mid.".jpg";
starttable();
tableheader("<span style=\"float: center;\">{$lang->delete} ".$medal_list['description']." <img src=\"".$imgsrc."\" width=\"20\" height=\"40\">?</span>");
echo "<tr><td><h2>{$lang->sure_to_del} ".$medal_list['description'];
echo " <img src=\"".$imgsrc."\" width=\"20\" height=\"40\"></h2></td></tr>";
startform($_SERVER['PHP_SELF'],"POST");
echo makehiddencode("mid",$medal_list['mid']);
echo "<tr><td>";
echo makebuttoncode("action",$lang->kill_it);
echo "</td></tr>";
endform();
endtable();

}

function perform_delete($mid)
{
global $mybb,$db,$lang;
starttable();
tableheader("<span style=\"float: center;\">{$lang->del_status}</span>");
$medals_query = $db->query("select * from `".TABLE_PREFIX."medals_list` where mid=".$mid);
$medal_list = $db->fetch_array($medals_query);
$dirpath = MYBB_ROOT.$mybb->settings['uploadspath'].'/medals';
$bgcolor = getaltbg();
if (!unlink($dirpath."/".$mid.".jpg"))
echo "<tr><td class=\"{$bgcolor}\">{$lang->file_delete_fail}</tr></td>";
else 
echo "<tr><td class=\"{$bgcolor}\">{$lang->file_delete_pass}</td></tr>";
$bgcolor = getaltbg();
echo "<tr><td class=\"{$bgcolor}\">{$lang->purging_mgr_table}</td></tr>";
$db->query("delete from `".TABLE_PREFIX."medals_managers` where mid=".$mid);
$bgcolor = getaltbg();
echo "<tr><td class=\"{$bgcolor}\">{$lang->purging_awd_table}</td></tr>";
$db->query("delete from `".TABLE_PREFIX."medals_awarded` where mid=".$mid);
$bgcolor = getaltbg();
echo "<tr><td class=\"{$bgcolor}\">{$lang->purging_lst_table}</td></tr>";
$db->query("delete  from `".TABLE_PREFIX."medals_list` where mid=".$mid);
endtable();
  show_medals_list();
        show_medal_upload_form();

}

function add_manager_submit($mid,$username)
{
global $mybb,$db,$lang;

	starttable();
	if (!$uid = username_to_uid($username))
	{
	tableheader("<span style=\"float: center;\">{$lang->mgr_upd_fail}</span>");
	echo $lang->bad_uname_try_again;
	endtable(); 
	exit();
	}
	else
	{
		if ($db->query("insert into `".TABLE_PREFIX."medals_managers` (`mid`,`uid`) VALUES(".$mid.",".$uid.")"))
		{
		tableheader("<span style=\"float: center;\">{$lang->mgr_upd_pass}</span>");
		echo "<tr><td>".$username ." {$lang->added_to_mgr}</td></tr>";
		}
		else
		{
		tableheader("<span style=\"float: center;\">{$lang->mgr_upd_fail}</span>");
		echo "<tr><td>Bad Query</td></tr>";
		}
	endtable(); 
	edit_managers_form($mid);
         add_managers_form($mid);
		
	}

}


function confirm_medal_edit($mid)
{
     global $db,$mybb,$lang;

        $description = $db->escape_string($mybb->input['description']);

$tableopen = 0;
	if ($_FILES['medalfile']['name'])
	{
        
	$dirpath = MYBB_ROOT.$mybb->settings['uploadspath'].'/medals';

        if ($_FILES['medalfile']['error'] == '0')
        {
                $imgfile = $_FILES['medalfile']['tmp_name'];
                $newfile = $dirpath . "/" . $mid . ".jpg";
                if (!copy($imgfile, $newfile))
                {
                        // if an error occurs the file could not
                        // be written, read or possibly does not exist
                        die($lang->err_upload." ".$newfile);
                }
	starttable();
	$tableopen = 1;
        tableheader("<span style=\"float: center;\">{$lang->medal_upd}</span>");
        echo "<tr><td>{$lang->medal} ".$mybb->input['description']." {$lang->img_upd}</td></tr>";
        }
        else
        echo "errors: ".$_FILES['medalfile']['error'];
	}
	$db->query("update `".TABLE_PREFIX."medals_list` set `description` = \"".$description."\" where `mid` = ".$mid); 

	$imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath']."/medals/".$mid.".jpg";
		if ($tableopen == '0')
		{
		starttable();
		tableheader("<span style=\"float: center;\">{$lang->medal_upd}</span>");
		}
	echo "<tr><td>{$lang->medal} ".$mybb->input['description']."<img src=\"".$imgsrc."\" width=\"20\" height=\"40\"> {$lang->desc_upd}</td></tr>";
	endtable();
        show_medals_list();
        show_medal_upload_form();


}


function username_to_uid($username)
{
global $db;
 $query = $db->query("SELECT uid FROM ".TABLE_PREFIX."users WHERE username='".$db->escape_string($username)."' LIMIT 1");
        if($uid = $db->fetch_array($query))
        {
                return $uid['uid'];
        }
        else
        {
                return false;
        }
}

function uid_to_username($uid)
{
global $db;
 $query = $db->query("SELECT username FROM ".TABLE_PREFIX."users WHERE uid='".$db->escape_string($uid)."' LIMIT 1");
        if($username = $db->fetch_array($query))
        {
                return $username['username'];
        }
        else
        {
                return false;
        }
}


?>
