<?php
/**
 *   Medals System Plugin for MyBB
 *   Website: http://www.ncaabbs.com
 *   Version: 1.1
 *   Copyright  2007
 *   King Butter - NCAAbbs SkunkWorks Team
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License along
 *   with this program; if not, write to the Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

if(!defined("IN_MYBB"))
{
    die("You cannot access this file directly. Go to hell and die.");
}

$plugins->add_hook("postbit_author_user", "get_medals");
$plugins->add_hook("usercp_menu", "usercp_nav_add",40);
$plugins->add_hook("admin_adminoptions_adminpermissions_yesnocodes", "medals_adminperms_yesnocode");
$plugins->add_hook("admin_adminoptions_do_updateperms", "medals_adminoptions_do_updateperms");
$plugins->add_hook("admin_index_navigation_end", "medals_admin_nav");
function medals_info()
{
	return array(
		'name'			=> 'SkunkMedals System',
		'description'		=> 'Add a fully functional Medals System to MyBB.',
		'version'		=> '1.1',
		'website'		=> 'http://www.ncaabbs.com/~kingbutter/mybb/SkunkMedals',
		'author'		=> 'King Butter - NCAABBS SkunkWorks Team',
		'authorsite'		=> 'http://www.ncaabbs.com/~kingbutter'
	);
}

function medals_activate()
{
global $mybb,$db,$config;
require MYBB_ROOT.'/inc/adminfunctions_templates.php';

// Create Medals Dir
$dirstatus = mkdir(MYBB_ROOT.$mybb->settings['uploadspath'].'/medals');
if (!$dirstatus)
{
echo "Failed to create medals directory. Please Create ".MYBB_ROOT.$mybb->settings['uploadspath']."/medals";
}

// Create `medals_list` table
	$db->query("
		CREATE TABLE `".TABLE_PREFIX."medals_list` (
			mid smallint unsigned NOT NULL auto_increment,
			description varchar(120) NOT NULL default '',
			PRIMARY KEY (`mid`)
		) TYPE=MyISAM;
	");

// Create `medals_manager` table
	$db->query("
		CREATE TABLE `".TABLE_PREFIX."medals_managers` (
			mid smallint unsigned NOT NULL,
			uid int(10) NOT NULL
		) TYPE=MyISAM;
	");

// Create `medals_awarded` table
	$db->query("
		CREATE TABLE `".TABLE_PREFIX."medals_awarded` (
			mid smallint unsigned NOT NULL,
			uid int(10) NOT NULL,
			status smallint unsigned NOT NULL DEFAULT 1
		) TYPE=MyISAM;
	");

	// Add admin permissions entry to `adminoptions` table
	$db->query("ALTER TABLE `".TABLE_PREFIX."adminoptions` ADD `canadminmedals` CHAR(3) NOT NULL default 'yes'");
	
	// Grant usage permissions to super admins
	$db->query("UPDATE `".TABLE_PREFIX."adminoptions` SET `canadminmedals`='yes'");

//Find and replace on Templates to add the Medals
find_replace_templatesets("postbit_author_user", '#'.preg_quote('{$post[\'user_details\']}').'#', '{$post[\'user_details\']} {$post[\'medals\']}');

// Create Template for User Control Panel (for medal managers)
$menutemplate = '<tr>
<td class="tcat"><span class="smalltext"><strong>{\$lang->skunkworks_menu_header}</strong></span></td></tr>
<tr>
<td class="trow1">
<ul class="usercpnav">
<li><a href="medals.php">{\$lang->medals}</a></li>
</ul>
</td>
</tr>
';
$db->query("INSERT INTO `".TABLE_PREFIX."templates` VALUES (NULL, 'usercp_nav_skunkworks', '$menutemplate', '-1', '120', '', '1157739093')");


}

function medals_deactivate()
{
require  MYBB_ROOT.'/inc/adminfunctions_templates.php';
global $db, $mybb;
	
	// Remove `downloadcategories` and `downloads` tables
	$db->query("DROP TABLE ".TABLE_PREFIX."medals_list");
	$db->query("DROP TABLE ".TABLE_PREFIX."medals_awarded");
	$db->query("DROP TABLE ".TABLE_PREFIX."medals_managers");
	find_replace_templatesets("postbit_author_user", '#'.preg_quote('{$post[\'medals\']}').'#', '',0);
	$db->query("alter table ".TABLE_PREFIX."adminoptions drop canadminmedals");
	$db->query("delete from `".TABLE_PREFIX."templates` where `title` = 'usercp_nav_skunkworks'");
        $dirname = MYBB_ROOT.$mybb->settings['uploadspath'].'/medals';
	$directory = opendir($dirname);
	while($file=readdir($directory))
	{
		if($file!="." && $file!="..")
		{
		unlink($dirname."/".$file);
		}
	} 
	@rmdir($dirname);

}

function get_medals($post)
{

global $db, $mybb,$config;
$uid=intval($post['uid']);

// check Number of medals, exit if no medals
$query = $db->simple_select(TABLE_PREFIX.'medals_awarded', 'COUNT(*) AS count',"uid=".$uid);
	$medal_count = $db->fetch_array($query);
	if($medal_count['count'] > 0)
	{
	$post['medals'] = "<br />";
        $medals_query = $db->query("select `mid` from `". TABLE_PREFIX."medals_awarded` where `uid`='".$uid."'");
		while($medals_list = $db->fetch_array($medals_query))
        	{
                $medal_query = $db->query("select `mid`,`description` from `".TABLE_PREFIX."medals_list` where `mid` = '".$medals_list['mid']."'");
		$medal = $db->fetch_array($medal_query);
	        $imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath'].'/medals/'.$medal['mid'].'.jpg';
		$post['medals'] .= "<img src=\"{$imgsrc}\" width=\"20\" height=\"40\" alt=\"{$medal['description']}\"  title=\"{$medal['description']}\">";
		}
	}
	
}


function medals_adminoptions_do_updateperms()
{
  	global $sqlarray, $newperms, $db, $mybb;
  		$sqlarray['canadminmedals'] = $db->escape_string($newperms['canadminmedals']);
  	return $sqlarray;
}

function medals_adminperms_yesnocode()
{
  	global $permissions, $lang, $mybb;
  	
  		makeyesnocode("Can Administer Medals", "newperms[canadminmedals]", $permissions['canadminmedals']);
}

function medals_admin_nav()
{
global $menu, $mybb, $lang;
	
		$menu[60]['items'][] = array('title' => "Madalya Admin", 'url' => "medals.php?".SID);
		$menu[60]['items'][] = array('title' => "Madalya Alanlar", 'url' => "../medals.php?".SID);

}

function usercp_nav_add()
{
global $mybb, $theme,$db, $templates,$lang,$usercpmenu;
        $lang->load("medals");
        eval("\$usercpmenu .= \"".$templates->get("usercp_nav_skunkworks")."\";");

}
?>
